using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Configuration;
using System.Diagnostics;

using Talinum.XMLengine.XMLengine;


namespace CustTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Client : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label txtHierarchy;
		private System.Windows.Forms.Label txtSPDef;
		private System.Windows.Forms.Label txtSession;
		private System.Windows.Forms.Button btnViewHierarchy;
		private System.Windows.Forms.Button btnViewSPDef;
		private System.Windows.Forms.Button btnViewSession;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button btnProcess;
		private System.Windows.Forms.Button btnViewLog;
		private System.Windows.Forms.Button btnExit;
		private System.Windows.Forms.Label label4;

		private string m_hierPath = string.Empty;
		private string m_spnamePath = string.Empty;
		private string m_sessionPath = string.Empty;
		private string m_src = string.Empty;
		private System.Windows.Forms.Button btnInstructions;
		private System.Windows.Forms.Label label5;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Client()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.txtHierarchy = new System.Windows.Forms.Label();
			this.txtSPDef = new System.Windows.Forms.Label();
			this.txtSession = new System.Windows.Forms.Label();
			this.btnViewHierarchy = new System.Windows.Forms.Button();
			this.btnViewSPDef = new System.Windows.Forms.Button();
			this.btnViewSession = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnExit = new System.Windows.Forms.Button();
			this.btnViewLog = new System.Windows.Forms.Button();
			this.btnProcess = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.btnInstructions = new System.Windows.Forms.Button();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(48, 112);
			this.label1.Name = "label1";
			this.label1.TabIndex = 5;
			this.label1.Text = "HierarchyPath:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(48, 152);
			this.label2.Name = "label2";
			this.label2.TabIndex = 6;
			this.label2.Text = "SPDefPath:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(48, 192);
			this.label3.Name = "label3";
			this.label3.TabIndex = 7;
			this.label3.Text = "SessionPath:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtHierarchy
			// 
			this.txtHierarchy.Location = new System.Drawing.Point(168, 112);
			this.txtHierarchy.Name = "txtHierarchy";
			this.txtHierarchy.Size = new System.Drawing.Size(240, 23);
			this.txtHierarchy.TabIndex = 8;
			this.txtHierarchy.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtSPDef
			// 
			this.txtSPDef.Location = new System.Drawing.Point(168, 152);
			this.txtSPDef.Name = "txtSPDef";
			this.txtSPDef.Size = new System.Drawing.Size(240, 23);
			this.txtSPDef.TabIndex = 9;
			this.txtSPDef.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtSession
			// 
			this.txtSession.Location = new System.Drawing.Point(168, 192);
			this.txtSession.Name = "txtSession";
			this.txtSession.Size = new System.Drawing.Size(240, 23);
			this.txtSession.TabIndex = 10;
			this.txtSession.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnViewHierarchy
			// 
			this.btnViewHierarchy.Location = new System.Drawing.Point(432, 112);
			this.btnViewHierarchy.Name = "btnViewHierarchy";
			this.btnViewHierarchy.TabIndex = 11;
			this.btnViewHierarchy.Text = "View";
			this.btnViewHierarchy.Click += new System.EventHandler(this.btnViewHierarchy_Click);
			// 
			// btnViewSPDef
			// 
			this.btnViewSPDef.Location = new System.Drawing.Point(432, 152);
			this.btnViewSPDef.Name = "btnViewSPDef";
			this.btnViewSPDef.TabIndex = 12;
			this.btnViewSPDef.Text = "View";
			this.btnViewSPDef.Click += new System.EventHandler(this.btnViewSPDef_Click);
			// 
			// btnViewSession
			// 
			this.btnViewSession.Location = new System.Drawing.Point(432, 192);
			this.btnViewSession.Name = "btnViewSession";
			this.btnViewSession.TabIndex = 13;
			this.btnViewSession.Text = "View";
			this.btnViewSession.Click += new System.EventHandler(this.btnViewSession_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label5);
			this.groupBox2.Controls.Add(this.btnExit);
			this.groupBox2.Controls.Add(this.btnViewLog);
			this.groupBox2.Controls.Add(this.btnProcess);
			this.groupBox2.Location = new System.Drawing.Point(24, 232);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(488, 120);
			this.groupBox2.TabIndex = 14;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Process";
			this.groupBox2.Enter += new System.EventHandler(this.groupBox2_Enter);
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(368, 80);
			this.btnExit.Name = "btnExit";
			this.btnExit.Size = new System.Drawing.Size(96, 23);
			this.btnExit.TabIndex = 2;
			this.btnExit.Text = "Exit";
			this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
			// 
			// btnViewLog
			// 
			this.btnViewLog.Location = new System.Drawing.Point(200, 80);
			this.btnViewLog.Name = "btnViewLog";
			this.btnViewLog.Size = new System.Drawing.Size(96, 23);
			this.btnViewLog.TabIndex = 1;
			this.btnViewLog.Text = "View Log";
			this.btnViewLog.Click += new System.EventHandler(this.button2_Click);
			// 
			// btnProcess
			// 
			this.btnProcess.Location = new System.Drawing.Point(40, 80);
			this.btnProcess.Name = "btnProcess";
			this.btnProcess.Size = new System.Drawing.Size(88, 23);
			this.btnProcess.TabIndex = 0;
			this.btnProcess.Text = "Process Now!";
			this.btnProcess.Click += new System.EventHandler(this.btnProcess_Click);
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(16, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(376, 72);
			this.label4.TabIndex = 15;
			this.label4.Text = "Modify App.config to choose from 2 Test Cases. Currently Active Test Case:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnInstructions
			// 
			this.btnInstructions.Location = new System.Drawing.Point(416, 40);
			this.btnInstructions.Name = "btnInstructions";
			this.btnInstructions.Size = new System.Drawing.Size(104, 32);
			this.btnInstructions.TabIndex = 16;
			this.btnInstructions.Text = "View Instructions";
			this.btnInstructions.Click += new System.EventHandler(this.btnInstructions_Click);
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(32, 24);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(288, 48);
			this.label5.TabIndex = 3;
			this.label5.Text = "Hold on, before you start, please make sure database is already setup and connect" +
				"ion string properly configured. Click \"View Instructions\" button for details!";
			// 
			// Client
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 389);
			this.Controls.Add(this.btnInstructions);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.btnViewSession);
			this.Controls.Add(this.btnViewSPDef);
			this.Controls.Add(this.btnViewHierarchy);
			this.Controls.Add(this.txtSession);
			this.Controls.Add(this.txtSPDef);
			this.Controls.Add(this.txtHierarchy);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "Client";
			this.Text = "Talinum XMLengine Client";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Client());			
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.m_hierPath = ConfigurationSettings.AppSettings["HierarchyPath"];
			this.m_spnamePath = ConfigurationSettings.AppSettings["SPDefPath"];
			this.m_sessionPath = ConfigurationSettings.AppSettings["SessionPath"];

			this.txtHierarchy.Text = this.m_hierPath;
			this.txtSession.Text = this.m_sessionPath;
			this.txtSPDef.Text = this.m_spnamePath;
		}

		private void radioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox1_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox2_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			RunApp(@"testXmlEngine.log");
		}

		private void moderateCase_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}

		private void btnProcess_Click(object sender, System.EventArgs e)
		{
			this.btnProcess.Enabled = false;

			StreamReader rdr = new StreamReader(this.m_sessionPath);
			this.m_src = rdr.ReadToEnd();
			rdr.Close();

			try 
			{
				for (int i = 0; i < 10; i ++)
				{
					XMLengine loader = new XMLengine(this.m_hierPath, this.m_spnamePath);
					loader.Process(this.m_src);
				}
				MessageBox.Show("XMLengine Process Completed.");
			}
			catch (Exception exp) 
			{
				MessageBox.Show(exp.Message, "Process incomplete!");
				Trace.WriteLine(exp.Message, "Error");
			}
			finally
			{
				Trace.Flush();
				this.btnProcess.Enabled = true;
			}


		}

		private void btnExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnViewHierarchy_Click(object sender, System.EventArgs e)
		{
			RunApp(this.txtHierarchy.Text);
		}

		private void btnViewSPDef_Click(object sender, System.EventArgs e)
		{
			RunApp(this.txtSPDef.Text);		
		}

		private void btnViewSession_Click(object sender, System.EventArgs e)
		{
			RunApp(this.txtSession.Text);
		}
		private void RunApp(string fileName) 
		{
			try 
			{
				Process.Start(fileName);
			}
			catch (Exception ex) 
			{
				MessageBox.Show(ex.Message);
			}		
		}

		private void btnInstructions_Click(object sender, System.EventArgs e)
		{
			RunApp(@"../../Readme First.txt");		
		
		}
	}
}
